#############################
#
#           Amus'Art
#
# Copyright 2008,2009 Newmagic
#
#    This file is part of Amus'Art.
#
#    You can redistribute and/or modify
#    this software under the terms of the
#    Creative Commons  Attribution-NonCommercial-ShareAlike 3.0 Legal Code
#
#    See COPYING file(s) join to the distribution and/or
#    http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode
#
#############################

global PARAM

set PARAM(rep) [info script]
set PARAM(rep) [file dirname $PARAM(rep)]
cd $PARAM(rep)

set PARAM(nomAppli) "AmusArt"
set PARAM(nomLongAppli) "Amus'Art"
set PARAM(verAppli) "v0.2.1"
set PARAM(dateVer) "02/02/2009"
set PARAM(vitesse) 1

source [file join "Lib" "Lib_fichiers.tcl"]

global NOM_FIC_OPTIONS
set NOM_FIC_OPTIONS [cheminComplet "options.ini"]

global LISTE_EXT_SAUV
set LISTE_EXT_SAUV {
    {{Dessins} {.cnv}}
}

global REP_SAUV
set REP_SAUV [cheminComplet "Dessins"]
if {![file exists $REP_SAUV]} {
  creerRep $REP_SAUV
  foreach fic [listeFic "*" "Dessins"] {
    catch {file copy [file join "Dessins" $fic] [file join $REP_SAUV $fic]}
  }
}

source "$PARAM(nomAppli)\_interface.tcl"

proc quitter {} {
  global NOM_FIC_OPTIONS
  global messages
  global langueAffichage

  set rep [msgBox $messages(DDE_SAUV,$langueAffichage) $messages(LIB_QUIT,$langueAffichage) "yesnocancel"]
  if {$rep != "cancel"} {
    if {$rep == "yes"} {
      sauverDessin
    }
    sauverGlobales $NOM_FIC_OPTIONS [list couleurs couleurEcriture tailleEcriture langueAffichage vitesseAffichage niveauZoom]
    exit
  }
}

wm protocol . WM_DELETE_WINDOW {quitter}

proc sauverDessin {{nomDessin ""} {rapide false}} {
  global PARAM
  global LISTE_EXT_SAUV
  global REP_SAUV
  global messages
  global langueAffichage

  if {$nomDessin == ""} {
#    set nomFic [tk_getSaveFile -filetypes $LISTE_EXT_SAUV -defaultextension $ext -initialdir [file join $PARAM(rep) $REP_SAUV] -title "Sauvegarder"]
    set nomDessin [inputBox [list "$messages(DDE_NOM,$langueAffichage)"] "$messages(LIB_SAUV,$langueAffichage)" [list ""] "#ffffff"]
  }
  if {$nomDessin != ""} {
    set ext [lindex [lindex $LISTE_EXT_SAUV 0] 1]
    set longExt [expr {[string length $ext] - 1}]
    set nomFic [file join $REP_SAUV $nomDessin]
    if {"[string tolower [string range $nomFic end-$longExt end]]" != "$ext"} {
      append nomFic "$ext"
    }
    set ok true
    if {[file exists $nomFic]} {
      set ok [msgBox "$messages(DDE_ECRASE,$langueAffichage)" "$messages(LIB_SAUV,$langueAffichage)" "yesno" "warning"]
    }
    if {$ok} {
      afficherFrmAttente "$messages(MSG_ATTENTE_SAUV,$langueAffichage)"
      ecrireFichier "$nomFic" [sauveCanvas .frmDessin.cnv] 1
      afficherFrame frmDessin
      if {! $rapide} {
        msgBox "$messages(CONF_SAUV,$langueAffichage)" "$messages(LIB_SAUV,$langueAffichage)"
      }
    }
  }
}

# si une liste est spcifie, c'est que l'on vient de valider frmOuvrir
proc chargerDessin {{liste ""}} {
  global PARAM
  global LISTE_EXT_SAUV
  global REP_SAUV
  global messages
  global langueAffichage

  if {$liste == ""} {
#    set nomFic [tk_getOpenFile -filetypes $LISTE_EXT_SAUV -initialdir [file join $PARAM(rep) $REP_SAUV] -title "Charger"]
    afficherFrmOuvrir "$messages(LIB_OUVR,$langueAffichage)" "$messages(LIB_ANNUL,$langueAffichage)"
  } else {
    set indDansListe [.frmOuvrir.lstDessins curselection]
    if {$indDansListe >= 0} {
      set nomFic "[lindex $liste $indDansListe]"
      restaurerCanvasDessin [lireFichier [file join $REP_SAUV "$nomFic"]] 15
    } else {
      msgBox "$messages(ERR_CHOIX_DESSIN,$langueAffichage)" "$messages(LIB_OUVR,$langueAffichage)" "ok" "error"
    }
  }
}