#############################
#
#           Amus'Art
#
# Copyright 2008,2009 Newmagic
#
#    This file is part of Amus'Art.
#
#    You can redistribute and/or modify
#    this software under the terms of the
#    Creative Commons  Attribution-NonCommercial-ShareAlike 3.0 Legal Code
#
#    See COPYING file(s) join to the distribution and/or
#    http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode
#
#############################

global PARAM

utiliseLibrairie "interface"

utiliseLibrairie "outils"

if {$PARAM(machine) == "PPC"} {
  refermerClavier ;# "referme" le clavier, au cas o...
#  utiliseLibrairie "he-dialog"
}

# Valeurs par dfaut :
set PARAM(hauteur) 640
set PARAM(largeur) 480
set PARAM(fichierMenu) "" ;#[file join $REP_MENUS "Menu.txt"]
set PARAM(msgAccueil) "$PARAM(nomLongAppli)"
#set PARAM(taillePoliceBase) 5
set couleurs(FondFenetre) "#000000"
set couleurs(Police) "#000000"
set polices(Titre) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 8}] -weight bold]
set polices(Normale) [font create -family Courier -size $PARAM(taillePoliceBase) -weight bold]

# Puis excution du fichier des paramtres, selon la machine :
source "initParamsInterface_$PARAM(machine)\.ini"
#source "initParamsInterface_PPC.ini"

initFenetre $PARAM(nomAppli) $PARAM(largeur) $PARAM(hauteur)
#creerMenuFichier "$PARAM(fichierMenu)"


afficherFrmAttente "$PARAM(nomAppli) $PARAM(verAppli)" "..."
update

# Messages, selon la langue :
global messages
set messages(<id>,<langue>) "texte"

set messages(DDE_SAUV,FR) "Voulez-vous sauvegarder le dessin en cours ?"
set messages(LIB_QUIT,FR) "Quitter"
set messages(DDE_NOM,FR) "Nom de votre dessin :"
set messages(LIB_SAUV,FR) "Sauver"
set messages(DDE_ECRASE,FR) "Un dessin existe dj sous ce nom. Voulez-vous l'craser ?"
set messages(CONF_SAUV,FR) "Dessin sauv !"
set messages(ERR_CHOIX_DESSIN,FR) "Vous devez choisir un dessin..."
set messages(LIB_OUVR,FR) "Charger"
set messages(LIB_ANNUL,FR) "Annuler"
set messages(MSG_ATTENTE_SAUV,FR) "Sauvegarde en cours...\nVeuillez patienter..."

set messages(DDE_SAUV,EN) "Do you want to save your work ?"
set messages(LIB_QUIT,EN) "Exit"
set messages(DDE_NOM,EN) "Save as :"
set messages(LIB_SAUV,EN) "Save"
set messages(DDE_ECRASE,EN) "Name already used. Write anyway ?"
set messages(CONF_SAUV,EN) "Done !"
set messages(ERR_CHOIX_DESSIN,EN) "You have to choose a drawing..."
set messages(LIB_OUVR,EN) "Load"
set messages(LIB_ANNUL,EN) "Cancel"
set messages(MSG_ATTENTE_SAUV,EN) "" ;# On prendra le message par dfaut


proc cloneCanvas {canvas clone} {
  restoreCanvas $clone [sauveCanvas $canvas]
}

proc listeOptionsValeursWidget {options} \
{
  set res {}
  foreach option $options \
  {
    set key   [lindex $option 0]
    set value [lindex $option 4]
    if {$value != ""} { lappend res [list $key $value] }
  }
  return $res
}

# Fonction permettant de rcuprer la liste des options, valeurs, bindings, etc. d'un canvas
# dans le but de sauvegarder son contenu
proc sauveCanvas {w} \
{
  # canvas name
  lappend save $w
  # canvas option
  lappend save [listeOptionsValeursWidget [$w configure]]
  # canvas focus
  lappend save [$w focus]
  # canvas items
  foreach id [$w find all] \
  {
    set item {}
    # type & id
    set type [$w type $id]
    lappend item [list $type $id]
    # coords
    lappend item [$w coords $id]
    # tags
    set tags [$w gettags $id]
    lappend item $tags
    # binds
    set binds {}
    # id binds
    set events [$w bind $id]
    foreach event $events \
    { lappend binds [list $id $event [$w bind $id $event]] }
    # tags binds
    foreach tag $tags \
    {
      set events [$w bind $tag]
      foreach event $events \
      { lappend binds [list $tag $event [$w bind $tag $event]] }
    }
    lappend item $binds
    # options
    lappend item [listeOptionsValeursWidget [$w itemconfigure $id]]
    # type specifics
    set specifics {}
    switch $type \
    {
      arc       {}
      bitmap    {}
      image     \
      {
        # image name
        set iname [$w itemcget $id -image]
        lappend specifics $iname
        # image type
        lappend specifics [image type $iname]
        # image options
        lappend specifics [listeOptionsValeursWidget [$iname configure]]
      }
      line      {}
      oval      {}
      polygon   {}
      rectangle {}
      text      \
      {
        foreach index {insert sel.first sel.last} \
        {
          # text indexes
          catch \
          { lappend specifics [$w index $id $index] }
        }
      }
      window    \
      {
        # window name
        set wname [$w itemcget $id -window]
        lappend specifics $wname
        # window type
        lappend specifics [string tolower [winfo class $wname]]
        # window options
        lappend specifics [listeOptionsValeursWidget [$wname configure]]
      }
    }
    lappend item $specifics
    lappend save $item
  }
  # return serialized canvas
  return $save
}

# Restauration d'un canvas sauv prcdemment
# w = nouveau canvas
# save = liste issue de sauveCanvas
proc restoreCanvas {w save {pause 0} {facteurZoom 1.0}} \
{
  global vitesseAffichage

  # create canvas options
  catch {canvas $w}
  eval $w configure [join [lindex $save 1]]
  # items
  foreach item [lrange $save 3 end] \
  {
    foreach {typeid coords tags binds options specifics} $item \
    {
      # get type
      set type [lindex $typeid 0]
      # create bitmap or window
      switch $type \
      {
        image   \
        {
          foreach {iname itype ioptions} $specifics break
          if {![image inuse $iname]} \
          { eval image create $itype $iname [join $ioptions] }
        }
        window  \
        {
          foreach {wname wtype woptions} $specifics break
          if {![winfo exists $wname]} \
          { eval $wtype $wname [join $woptions] }
          raise $wname
        }
      }
      # create item
      if {$facteurZoom != 1.0} {
        set listeCoordsTmp $coords
        set coords [list]
        foreach coord $listeCoordsTmp {
          lappend coords [expr {1.0 * $facteurZoom * $coord}]
        }
      }
      set id [eval $w create $type $coords -tags "{$tags}" [join $options]]
      # item bindings
      foreach bind $binds \
      {
        foreach {id event script} $bind { $w bind $id $event $script }
      }
      # item specifics
      if {$specifics != ""} \
      {
        switch $type \
        {
          text    \
          {
            foreach {insert sel.first sel.last} $specifics break
            $w icursor $id $insert
            if {${sel.first} != ""} \
            {
              $w select from $id ${sel.first}
              $w select to   $id ${sel.last}
            }
          }
        }
      }
    }
    if {$vitesseAffichage > 0 && $pause > 0} {
      pause $pause ;#15
    }
  }
  # focused item
  set focus [lindex $save 2]
  if {$focus != ""} \
  {
    $w focus [lindex $save 2]
    focus -force $w
  }
  # return path
  return $w
}



global xDessin
global yDessin
set xDessin 0
set yDessin 0
global bloque
set bloque false
proc dessinerCanvasDessin_cp {idWidget nx ny couleurEcriture {tailleEcriture 1}} {
  global xDessin
  global yDessin
  global bloque

  while {$bloque} {}
  set bloque true
  $idWidget create line $xDessin $yDessin $nx $ny -fill $couleurEcriture -width $tailleEcriture
  if {$tailleEcriture > 3 || ($nx == $xDessin && $ny == $yDessin)} {
    set x1 [expr {$nx - int($tailleEcriture / 2)}]
    set y1 [expr {$ny - int($tailleEcriture / 2)}]
    set x2 [expr {$x1 + $tailleEcriture - 1}]
    set y2 [expr {$y1 + $tailleEcriture - 1}]
    $idWidget create oval $x1 $y1 $x2 $y2 -fill $couleurEcriture -outline $couleurEcriture -width 1 ;#$tailleEcriture
  }
  set xDessin $nx
  set yDessin $ny
  set bloque false
}
proc dessinerCanvasDessin {idWidget nx ny couleurEcriture {tailleEcriture 1}} {
  global xDessin
  global yDessin

  set moitieTaille [expr {int($tailleEcriture / 2)}]
  set x1 [expr {$nx - $moitieTaille}]
  set y1 [expr {$ny - $moitieTaille}]
  set x2 [expr {$x1 + $tailleEcriture - 1}]
  set y2 [expr {$y1 + $tailleEcriture - 1}]
  $idWidget create oval $x1 $y1 $x2 $y2 -fill $couleurEcriture -outline $couleurEcriture -width 1 ;#$tailleEcriture
#set diffX [expr {$xDessin - $nx}]
#set diffY [expr {$yDessin - $ny}]
#if {$diffX < 0} {
#  set diffX [expr {0-$diffX}]
#}
#if {$diffY < 0} {
#  set diffY [expr {0-$diffY}]
#}
#  if {$diffX >= $tailleEcriture || $diffY >= $tailleEcriture} {
    $idWidget create line $xDessin $yDessin $nx $ny -fill $couleurEcriture -width $tailleEcriture
#  }
  set xDessin $nx
  set yDessin $ny
  update idletasks
}
proc setCanvasDessin {idWidget couleurEcriture tailleEcriture} {
  global xDessin
  global yDessin
  bind $idWidget <B1-Motion> "dessinerCanvasDessin $idWidget %x %y $couleurEcriture $tailleEcriture"
  bind $idWidget <Button-1> "
  set xDessin %x
  set yDessin %y
  dessinerCanvasDessin $idWidget %x %y $couleurEcriture $tailleEcriture"
}



proc nouvCanvas {} {
  global couleurEcriture
  global tailleEcriture
  global couleurs
  global niveauZoom

  destroy .frmDessin.cnv
  canvas .frmDessin.cnv -background $couleurs(FondFenetre)
  .frmDessin.cnv scale all 0 0 $niveauZoom $niveauZoom
  setCanvasDessin .frmDessin.cnv $couleurEcriture $tailleEcriture
  pack .frmDessin.cnv -expand true -fill both -side top
  majLangueAffichage
}

proc restaurerCanvasDessin {save {pause 0}} {
  global couleurEcriture
  global tailleEcriture
  global niveauZoom

  destroy .frmDessin.cnv
  canvas .frmDessin.cnv
#  .frmDessin.cnv scale all 0 0 $niveauZoom $niveauZoom
  if {$pause == 0} {
    afficherFrmAttente
  } else {
    pack .frmDessin.cnv -expand true -fill both -side top
    afficherFrame frmDessin
  }
  restoreCanvas .frmDessin.cnv $save $pause $niveauZoom
  setCanvasDessin .frmDessin.cnv $couleurEcriture $tailleEcriture
  if {$pause == 0} {
    pack .frmDessin.cnv -expand true -fill both -side top
    afficherFrame frmDessin
  }
  majLangueAffichage
}

proc changerCouleurFond {{nouvCoul ""}} {
  global couleurs

  if {$nouvCoul == ""} {
    set nouvCoul [choisirCouleur $couleurs(FondFenetre)]
  }
  if {$nouvCoul != ""} {
    .frmDessin.cnv configure -background $nouvCoul -borderwidth 0 ;#-relief flat ;#-bordercolor $nouvCoul
    .frmDessin configure -background $nouvCoul
    set couleurs(FondFenetre) $nouvCoul
    majConfig
  }
}

proc changerCouleurPinceau {{nouvCoul ""}} {
  global couleurEcriture
  global couleurs

  if {$nouvCoul == ""} {
    set nouvCoul [choisirCouleur $couleurEcriture]
  }
  if {$nouvCoul != ""} {
    set couleurEcriture $nouvCoul
    set couleurs(Police) $nouvCoul
    majConfig
  }
}

proc setTaillePinceau {nouvTaille} {
  global tailleEcriture
  if {$nouvTaille > 0} {
    set tailleEcriture $nouvTaille
    majConfig
  }
}

proc incrementerTaillePinceau {{increment 1}} {
  global tailleEcriture
  setTaillePinceau [expr {$tailleEcriture + $increment}]
}

proc majConfig {} {
  global couleurs
  global couleurEcriture
  global tailleEcriture

  .frmDessin.cnv configure -background $couleurs(FondFenetre)
  setCanvasDessin .frmDessin.cnv $couleurEcriture $tailleEcriture
  update idletasks
}

global pleinEcran
set pleinEcran false
proc basculerPleinEcran {} {
  global pleinEcran
  global PARAM

  if {$PARAM(machine) == "PPC"} {
    if {$pleinEcran} {
      catch {wce fullscreen .}
      destroy .menu10
    } else {
      catch {wce normal .}
    }
    majLangueAffichage
    update
  } else {
    set pleinEcran false
  }
}

proc majLangueAffichage {} {
  global langueAffichage
  global pleinEcran
  if {!$pleinEcran} {
    creerMenuFichier "Menu_$langueAffichage\.txt"
    desassocierMenuContextuel .frmDessin.cnv
  } else {
    associerMenuContextuel .frmDessin.cnv "MenuCtx_$langueAffichage\.txt"
  }
}
#majLangueAffichage

global lstFicDessins
set lstFicDessins [list]

proc afficherFrmOuvrir {libOk libAnnuler} {
  global lstFicDessins
  global couleurs
  global REP_SAUV
  global LISTE_EXT_SAUV

  set coulFond $couleurs(FondFenetre)
  destroy .frmOuvrir
  frame .frmOuvrir -background $coulFond
  ajouterLigneVideHaut frmOuvrir $coulFond
  ajouterLigneVideBas frmOuvrir $coulFond

  set ext [lindex [lindex $LISTE_EXT_SAUV 0] 1]
  set lstFicDessins [listeFic "*$ext" $REP_SAUV]
  ajouterFrame frmOuvrir frmBouttons $coulFond bottom
  pack configure .frmOuvrir.frmBouttons -expand false -fill none
  button .frmOuvrir.frmBouttons.cmdValider -text "$libOk" -command "chargerDessin [list $lstFicDessins]"
  button .frmOuvrir.frmBouttons.cmdAnnuler -text "$libAnnuler" -command "afficherFrame frmDessin"
  pack .frmOuvrir.frmBouttons.cmdValider .frmOuvrir.frmBouttons.cmdAnnuler -side "left" -padx 6 -pady 6

  listbox .frmOuvrir.lstDessins -listvariable lstFicDessins -yscrollcommand ".frmOuvrir.scrY set"
scrollbar .frmOuvrir.scrY -com {scrollY} -width 25
pack .frmOuvrir.scrY -side right -fill y
  pack .frmOuvrir.lstDessins -side right -expand true -fill both

  afficherFrame frmOuvrir
}

proc scrollY {args} {
  eval [list .frmOuvrir.lstDessins yview] $args
  update idletasks
}


global niveauZoom
set niveauZoom 1
proc zoomer {{augmenter true}} {
  global niveauZoom

  set pas 2
  if {! $augmenter} {
    set pas 0.5
  }
  .frmDessin.cnv scale all 0 0 $pas $pas
  set niveauZoom [expr {$niveauZoom * $pas}]
}

global couleurEcriture
global tailleEcriture
set couleurEcriture "#0000ff"
set tailleEcriture 3

global NOM_FIC_OPTIONS
catch {global vitesseAffichage;global couleurs;global couleurEcriture;chargerGlobales $NOM_FIC_OPTIONS;setVitesseAffichage $vitesseAffichage;set couleurs(Police) $couleurEcriture}

frame .frmDessin -background $couleurs(FondFenetre)
nouvCanvas
afficherFrame frmDessin
